#ifndef __BITBAND_H
#define __BITBAND_H

#include "stm32f103xb.h"

/*Peripheral GPIO bit-banding*/
#define BITBAND(addr, bitnum)   ((addr & 0xF0000000) + 0x2000000 + ((addr & 0xFFFFF) << 5) + (bitnum << 2))
#define MEM_ADDR(addr)          *((volatile uint32_t *)(addr))
#define BIT_ADDR(addr, bitnum)  MEM_ADDR(BITBAND(addr, bitnum))

/*IO mapping address*/
#define GPIOA_ODR_ADDR			(GPIOA_BASE + 12) //0x4001 080C
#define GPIOB_ODR_ADDR			(GPIOB_BASE + 12) //0x4001 0C0C
#define GPIOC_ODR_ADDR			(GPIOC_BASE + 12) //0x4001 100C
#define GPIOD_ODR_ADDR			(GPIOD_BASE + 12) //0x4001 400C
#define GPIOE_ODR_ADDR			(GPIOE_BASE + 12) //0x4001 800C

#define GPIOA_IDR_ADDR			(GPIOA_BASE + 8) //0x4001 0808
#define GPIOB_IDR_ADDR			(GPIOB_BASE + 8) //0x4001 0C08
#define GPIOC_IDR_ADDR			(GPIOC_BASE + 8) //0x4001 1008
#define GPIOD_IDR_ADDR			(GPIOD_BASE + 8) //0x4001 4008
#define GPIOE_IDR_ADDR			(GPIOE_BASE + 8) //0x4001 8008

/*define the IO function*/
#define PAout(n)		BIT_ADDR(GPIOA_ODR_ADDR, n)
#define PAin(n)			BIT_ADDR(GPIOA_IDR_ADDR, n)

#define PBout(n)		BIT_ADDR(GPIOB_ODR_ADDR, n)
#define PBin(n)			BIT_ADDR(GPIOB_IDR_ADDR, n)

#define PCout(n)		BIT_ADDR(GPIOC_ODR_ADDR, n)
#define PCin(n)			BIT_ADDR(GPIOC_IDR_ADDR, n)

#define PDout(n)		BIT_ADDR(GPIOD_ODR_ADDR, n)
#define PDin(n)			BIT_ADDR(GPIOD_IDR_ADDR, n)

#define PEout(n)		BIT_ADDR(GPIOE_ODR_ADDR, n)
#define PEin(n)			BIT_ADDR(GPIOE_IDR_ADDR, n)

#endif