#include "iic_gpio.h"

void MPU_IIC_Init(void);

/*
************************************************
*   : I2C_Delay
* ˵: I2Cλӳ٣400KHz
*     Σ
*   ֵ: 
************************************************
*/
static void I2C_Delay(void)
{
    uint8_t i;
    for(i=0; i<10; i++);
}

/*
************************************************
*   : I2C_Start
* ˵: CPUI2Cź
*     Σ
*   ֵ: 
************************************************
*/
void I2C_Start(void)
{
    I2C_SDA_1();
    I2C_SCL_1();
    I2C_Delay();
    I2C_SDA_0();
    I2C_Delay();
    I2C_SCL_0();
    I2C_Delay();
}

/*
************************************************
*   :I2C_Stop
* ˵: CPUI2Cֹͣź
*     Σ
*   ֵ: 
************************************************
*/
void I2C_Stop(void)
{
    I2C_SDA_0();
    I2C_SCL_1();
    I2C_Delay();
    I2C_SDA_1();
}

/*
************************************************
*   :I2C_SendByte
* ˵: CPUI2C豸8bit
*     Σ_ucByte:ȴ͵ֽ
*   ֵ: 
************************************************
*/
void I2C_SendByte(uint8_t _ucByte)
{
    uint8_t i;
    
    for(i=0; i<8; i++)
    {
        if(_ucByte&0x80)
        {
            I2C_SDA_1();
        }
        else
        {
            I2C_SDA_0();
        }
        
        I2C_Delay();
        I2C_SCL_1();
        I2C_Delay();
        I2C_SCL_0();
        
        if(i == 7)
        {
            I2C_SDA_1();
        }
        _ucByte <<= 1;
        I2C_Delay();
    }
}

/*
************************************************
*   :I2C_ReadByte
* ˵: CPUI2C豸ȡ8bit
*     Σ
*   ֵ: 
************************************************
*/
uint8_t I2C_ReadByte(uint8_t ack)
{
    uint8_t i;
    uint8_t value;
    
    value = 0;
    for(i=0; i<8; i++)
    {
        value <<= 1;
        I2C_SCL_1();
        I2C_Delay();
        if(I2C_SDA_READ())
        {
            value++;
        }
        I2C_SCL_0();
        I2C_Delay();
    }
    if(ack == 0)
      I2C_NAck();
    else
      I2C_Ack();
    return value;
}

/*
************************************************
*   :I2C_ReadByte
* ˵: CPUһʱӣȡACKӦź
*     Σ
*   ֵ: 0ʾȷӦ1ʾӦ
************************************************
*/
uint8_t I2C_WaitAck(void)
{
    uint8_t re;
    
    I2C_SDA_1();
    I2C_Delay();
    I2C_SCL_1();
    I2C_Delay();
    
    if(I2C_SDA_READ())
    {
        re = 1;
    }
    else
    {
        re = 0;
    }
    I2C_SCL_0();
    I2C_Delay();
    return re;
}


/*
************************************************
*    I2C_Ack
* ˵ CPUһACKź
*     Σ 
*   ֵ 
************************************************
*/
void I2C_Ack(void)
{
    I2C_SDA_0();
    I2C_Delay();
    I2C_SCL_1();
    I2C_Delay();
    I2C_SCL_0();
    I2C_Delay();
    I2C_SDA_1();
}

/*
************************************************
*    I2C_Ack
* ˵ CPUһNACKź
*     Σ 
*   ֵ 
************************************************
*/
void I2C_NAck(void)
{
    I2C_SDA_1();
    I2C_Delay();
    I2C_SCL_1();
    I2C_Delay();
    I2C_SCL_0();
    I2C_Delay();
}


/* Initiallize I2C GPIO*/
void I2C_GPIO_Configure(void)
{
	LL_GPIO_InitTypeDef GPIO_InitStructure;

	LL_APB2_GRP1_EnableClock(LL_APB2_GRP1_PERIPH_GPIOB);

	GPIO_InitStructure.Pin = LL_GPIO_PIN_10 | LL_GPIO_PIN_11;
	GPIO_InitStructure.Mode = LL_GPIO_OUTPUT_OPENDRAIN;
	GPIO_InitStructure.Speed = LL_GPIO_SPEED_FREQ_HIGH;

	LL_GPIO_Init(GPIOB, &GPIO_InitStructure);
	/* give a stop signal, reset all the device on I2C line*/
	I2C_Stop();
}

/*
************************************************
*   : I2C_CheckDevice
* ˵: I2C豸CPU豸ַȻȡ豸Ӧжϸ豸Ƿ
*     Σ_Address豸I2Cߵַ
*   ֵ: ֵ 0 ʾȷ 1ʾδ̽⵽
************************************************
*/
uint8_t I2C_CheckDevice(uint8_t _Address)
{
	uint8_t ucAck;

	I2C_GPIO_Configure();	/* GPIO */
	
	I2C_Start();		/* ź */

	I2C_SendByte(_Address|I2C_WR);
	ucAck = I2C_WaitAck();	/* 豸ACKӦ */

	I2C_Stop();	        /* ֹͣź */

	return ucAck;
}



