#include "mpuiic.h"

/*写数据到MPU6050寄存器*/

void MPU6050_WriteReg(uint8_t reg_add, uint8_t reg_dat)
{
    I2C_Start();
    I2C_SendByte(MPU6050_SLAVE_ADDRESS);
    I2C_WaitAck();
    I2C_SendByte(reg_add);
    I2C_WaitAck();
    I2C_SendByte(reg_dat);
    I2C_WaitAck();
    I2C_Stop();      
}


/*从MPU6050寄存器读数据*/

void MPU6050_ReadData(uint8_t reg_add, uint8_t *Read, uint8_t num)
{
    uint8_t i;
    
    I2C_Start();
    I2C_SendByte(MPU6050_SLAVE_ADDRESS);
    I2C_WaitAck();
    I2C_SendByte(reg_add);
    I2C_WaitAck();
    
    I2C_Start();
    I2C_SendByte(MPU6050_SLAVE_ADDRESS+1);
    I2C_WaitAck();
    
    for(i=0; i<num-1; i++)
    {
        *Read = I2C_ReadByte(1);
        Read++;
    }
    *Read = I2C_ReadByte(0);
    I2C_Stop();    
}


/*初始化MPU6050*/

void MPU6050_Init(void)
{
    int i=0, j=0;
    
    for(i=0; i<1000; i++)
    {
        for(j=0; j<1000; j++)
        {
            ;
        }
    }
    MPU6050_WriteReg(MPU6050_RA_PWR_MGMT_1, 0x00);
    MPU6050_WriteReg(MPU6050_RA_SMPLRT_DIV , 0x07);
    MPU6050_WriteReg(MPU6050_RA_CONFIG , 0x06);
    MPU6050_WriteReg(MPU6050_RA_ACCEL_CONFIG , 0x00);
    MPU6050_WriteReg(MPU6050_RA_GYRO_CONFIG, 0x18);   
}


/*读取MPU6050的ID*/

uint8_t MPU6050_ReadID(void)
{
    uint8_t Re = 0;
    
    MPU6050_ReadData(MPU6050_RA_WHO_AM_I,&Re,1);
    if(Re != 0x68)
    {
        printf("MPU6050 detected error!\r\n");
        return 0;
    }
    else
    {
        printf("MPU6050 ID = %d\r\n",Re);
        return 1;
    }
}





